viGroupManagerSetting = {};

function viGroupManagerSetting:clickButtonCallback(args)
	local color = "";
	local txt = "";
	if args.lineButton.ownTable.side == 1 then
		if args.lineButton.ownTable.whatClick == "viGroupLine_" then
			VehicleInspector.global.groupLine.isOn = not VehicleInspector.global.groupLine.isOn;
			VehicleInspector.global.groupLine.setting = false;
			g_currentMission.hlGui.setGet:setUnSave();
			return;
		elseif args.lineButton.ownTable.whatClick == "viIsGroup_" then
			VehicleInspector.seeVehicle.isGroup = not VehicleInspector.seeVehicle.isGroup;
			g_currentMission.hlGui.setGet:setUnSave();
			return;
		elseif args.lineButton.ownTable.whatClick == "viAutoSave_" then
			viGroupManager.profil.autoSave = not viGroupManager.profil.autoSave;			
			viGroupManager.profil.save = false;
			return;
		elseif args.lineButton.ownTable.whatClick == "viViewGroupTyp_" then
			VehicleInspector.global.groupLine.viewGroupTyp = not VehicleInspector.global.groupLine.viewGroupTyp;
			g_currentMission.hlGui.setGet:setUnSave();
			return;
		elseif args.lineButton.ownTable.whatClick == "viMohSlot_" then
			if not VehicleInspector.global.foundMoh then return;end;
			VehicleInspector.global.groupLine.mohSlot = not VehicleInspector.global.groupLine.mohSlot;
			g_currentMission.hlGui.setGet:setUnSave();
			return;
		elseif args.lineButton.ownTable.whatClick == "generateNewProfil_" then
			if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers["generateNewProfil"] == nil then
				g_currentMission.hl.addTimer({name="generateNewProfil", delay=5, repeatable=false});
			elseif g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers["generateNewProfil"] ~= nil then
				return;
			end;			
			viGroupManager:generateNewGroupProfil("NewProfil");			
			return;
		elseif args.lineButton.ownTable.whatClick == "loadProfil_" then
			if viGroupManager.profil.select == viGroupManager:getActiveProfil() then return;end;
			viGroupManager:setActiveProfil();			
			return;
		elseif args.lineButton.ownTable.whatClick == "deleteProfil_" then
			if viGroupManager.profil.select == viGroupManager:getActiveProfil() then return;end;
			viGroupManagerXml:deleteGroupProfil(viGroupManager.profil.select);
			viGroupManager.profil.select = viGroupManager:getActiveProfil();
			return;
		elseif args.lineButton.ownTable.whatClick == "editGroup_" then
			viGroupManager:editGroupName(viGroupManager.profil.groupSelect)
			g_currentMission.hlGui.setGet:setUnSave();
			return;
		end;
	end;
end;

function viGroupManagerSetting:txtButtonCallback(lineButton)
	local txtButton = "";
	if lineButton.ownTable.side == 1 then
		if lineButton.ownTable.whatClick == "viGroupLine_" then
			if VehicleInspector.global.groupLine.isOn then txtButton = "On";lineButton.clickButtonColor = "green";else txtButton = "Off";lineButton.clickButtonColor = "red";end;
		elseif lineButton.ownTable.whatClick == "viIsGroup_" then
			if VehicleInspector.seeVehicle.isGroup then txtButton = "On";lineButton.clickButtonColor = "green";else txtButton = "Off";lineButton.clickButtonColor = "red";end;
		elseif lineButton.ownTable.whatClick == "viViewGroupTyp_" then
			if VehicleInspector.global.groupLine.viewGroupTyp then txtButton = "On";lineButton.clickButtonColor = "green";else txtButton = "Off";lineButton.clickButtonColor = "red";end;
		elseif lineButton.ownTable.whatClick == "viAutoSave_" then
			if viGroupManager.profil.autoSave then txtButton = "On";lineButton.clickButtonColor = "green";else txtButton = "Off";lineButton.clickButtonColor = "red";end;
		elseif lineButton.ownTable.whatClick == "viMohSlot_" then
			if not VehicleInspector.global.foundMoh then 
				txtButton = "Mod MultiOverlayV4 not found";
				lineButton.clickButtonColor = "red";
			elseif VehicleInspector.global.groupLine.mohSlot then 
				txtButton = "On";
				lineButton.clickButtonColor = "green";
			else 
				txtButton = "Off";
				lineButton.clickButtonColor = "red";
			end;			
		elseif lineButton.ownTable.whatClick == "selectPullDownProfil_" then
			txtButton = tostring(viGroupManager.profil.select);
		elseif lineButton.ownTable.whatClick == "generateNewProfil_" then
			if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers["generateNewProfil"] ~= nil then
				txtButton = "Cooldown Timer active";
				lineButton.clickButtonColor = "red";
			else
				txtButton = "Generate New Profil";
				lineButton.clickButtonColor = "green";
			end;	
		elseif lineButton.ownTable.whatClick == "loadProfil_" then
			txtButton = tostring(viGroupManager.profil.select);
			if viGroupManager.profil.select == viGroupManager:getActiveProfil() then
				lineButton.clickButtonColor = "red";
			else
				lineButton.clickButtonColor = "ls15";
			end;
		elseif lineButton.ownTable.whatClick == "deleteProfil_" then
			txtButton = tostring(viGroupManager.profil.select);
			if viGroupManager.profil.select == viGroupManager:getActiveProfil() then
				lineButton.clickButtonColor = "red";
			else
				lineButton.clickButtonColor = "ls15";
			end;
		elseif lineButton.ownTable.whatClick == "selectPullDownGroup_" then
			txtButton = tostring(viGroupManager.groupsName[viGroupManager.profil.groupSelect]).. " (".. tostring(viGroupManager.profil.groupSelect).. ")";
		elseif lineButton.ownTable.whatClick == "editGroup_" then
			txtButton = "Group ".. tostring(viGroupManager.profil.groupSelect);
		end;	
	end;
	return txtButton
end;

function viGroupManagerSetting:pullDownCallback(lineButton)
	local pullDownTable = {}
	if lineButton.ownTable.side  == 1 then
		if lineButton.ownTable.whatClick == "selectPullDownProfil_" then
			for profilName, active in pairs(viGroupManager.groupProfile) do
				pullDownTable[#pullDownTable+1] = {
					txt = tostring(profilName);
					isSelect = active;
					callback = g_currentMission.hlGui.callbacks.vi["clickPullDownLine"];
					ownTable = {pageName="GroupManagerSetting", whatClick="selectPullDownProfil_",fileName=profilName};
				};			
			end;			
			function comp(w1,w2)			
				if w1.txt < w2.txt then
					return true;
				end;			
			end;	
			table.sort(pullDownTable, comp);
		elseif lineButton.ownTable.whatClick == "selectPullDownGroup_" then
			for group=1, viGroupManager.maxGroups do
				pullDownTable[#pullDownTable+1] = {
					txt = tostring(viGroupManager.groupsName[group]).. " (".. tostring(group).. ")";
					isSelect = group == viGroupManager.profil.groupSelect;
					callback = g_currentMission.hlGui.callbacks.vi["clickPullDownLine"];
					ownTable = {pageName="GroupManagerSetting", whatClick="selectPullDownGroup_",group=group};
				};			
			end;			
		end;
	end;
	return pullDownTable;
end;

function viGroupManagerSetting:clickPullDownLineCallback(args)
	if args.ownTable.whatClick == "selectPullDownProfil_" then
		viGroupManager.profil.select = args.ownTable.fileName;
	elseif args.ownTable.whatClick == "selectPullDownGroup_" then
		viGroupManager.profil.groupSelect = args.ownTable.group;
	end;
end;

function viGroupManagerSetting:generateSide(side)	
	local buttons = {};
	local color = ""
	local txtButton = "";
	if side == 1 then
		buttons = {
			[1] = {
				txtOverButton = "View Group Line";				
				txtButton = "On";
				txtBoldButton = true;
				txtButtonCallback = g_currentMission.hlGui.callbacks.vi["txtButton"];
				clickButton = "buttonOnOff";
				clickButtonColor = "green";
				clickButtonCallback = g_currentMission.hlGui.callbacks.vi["clickButton"];
				ownTable = {pageName="GroupManagerSetting", whatClick="viGroupLine_",side=side};
				txtInfo = "Activiere oder Deaktiviere die Fahrzeug Gruppen Anzeige.";
			};
			[2] = {
				txtOverButton = "View Groups";				
				txtButton = "On";
				txtBoldButton = true;
				txtButtonCallback = g_currentMission.hlGui.callbacks.vi["txtButton"];
				clickButton = "buttonOnOff";
				clickButtonColor = "green";
				clickButtonCallback = g_currentMission.hlGui.callbacks.vi["clickButton"];
				ownTable = {pageName="GroupManagerSetting", whatClick="viIsGroup_",side=side};
				txtInfo = "Zeigt Fahrzeuge mit an die in einer Gruppe sind (benötight view Groupnumber On)";
			};
			[3] = {
				txtOverButton = "View GroupTyp Number";				
				txtButton = "On";
				txtBoldButton = true;
				txtButtonCallback = g_currentMission.hlGui.callbacks.vi["txtButton"];
				clickButton = "buttonOnOff";
				clickButtonColor = "green";
				clickButtonCallback = g_currentMission.hlGui.callbacks.vi["clickButton"];
				ownTable = {pageName="GroupManagerSetting", whatClick="viViewGroupTyp_",side=side};
				txtInfo = "Zeigt die Fahrzeuge Typ Number mit an (Für Interne Zwecke)";
			};
			[4] = {
				txtOverButton = "Generate/Open/Close MOH Slot";				
				txtButton = "Off";
				txtBoldButton = true;
				txtButtonCallback = g_currentMission.hlGui.callbacks.vi["txtButton"];
				clickButton = "buttonOnOff";
				clickButtonColor = "red";
				clickButtonCallback = g_currentMission.hlGui.callbacks.vi["clickButton"];
				ownTable = {pageName="GroupManagerSetting", whatClick="viMohSlot_",side=side};
				txtInfo = "Erstellt und öffnet einen MOH Slot wenn man auf G mit rechter Maus klickt (benötight Mod MultiOverlayV4 Hud)";
			};			
		};
		g_currentMission.hlGui.setGet:generateModSideLine({modName="VehicleInspector", page=VehicleInspector.global.hlGui.page["GroupManagerSetting"], side=side, lineButtons=buttons});
		------------------
		buttons = {
			[1] = {
				txtButton = "Generate New Profil";				
				txtBoldButton = true;
				txtButtonCallback = g_currentMission.hlGui.callbacks.vi["txtButton"];
				clickButton = "buttonGenerate";
				clickButtonColor = "green";
				clickButtonCallback = g_currentMission.hlGui.callbacks.vi["clickButton"];
				ownTable = {pageName="GroupManagerSetting", whatClick="generateNewProfil_",side=side};
				txtInfo = "Erstellt ein neues Profil (Achtung das Profil wird nicht Automatisch geladen,sondern nur erstellt) ..modSettings/VehicleInspector/...";
			};			
			[2] = {
				visible = false;				
			};
			[3] = {
				visible = false;				
			};
			[4] = {
				txtOverButton = "Delete Map AutoSave";				
				txtButton = "On";
				txtBoldButton = true;
				txtButtonCallback = g_currentMission.hlGui.callbacks.vi["txtButton"];
				clickButton = "buttonOnOff";
				clickButtonColor = "green";
				clickButtonCallback = g_currentMission.hlGui.callbacks.vi["clickButton"];
				ownTable = {pageName="GroupManagerSetting", whatClick="viAutoSave_",side=side};
				txtInfo = "Speichert das Group Profil beim beenden des Spiels, ansonsten NICHT";				
			};
		};
		g_currentMission.hlGui.setGet:generateModSideLine({modName="VehicleInspector", page=VehicleInspector.global.hlGui.page["GroupManagerSetting"], side=side, lineButtons=buttons});
		------------------
		buttons = {
			[1] = {
				txtOverButton = "Group Profile";				
				txtButton = "";
				txtBoldButton = true;
				txtButtonCallback = g_currentMission.hlGui.callbacks.vi["txtButton"];			
				clickButton = "buttonDown";
				pullDownButton = true;
				pullDownCallback = g_currentMission.hlGui.callbacks.vi["pullDownButton"];
				ownTable = {pageName="GroupManagerSetting", whatClick="selectPullDownProfil_",side=side};
				txtInfo = "Markiere ein Group Profil welches du laden oder löschen möchstest. Die Group Profile befinden sich im Ordner ..modSettings/VehicleInspector/...";
			};
			[2] = {
				txtOverButton = "Load Group Profil";				
				txtButton = "";
				txtBoldButton = true;
				txtButtonCallback = g_currentMission.hlGui.callbacks.vi["txtButton"];			
				clickButton = "buttonLoad";				
				clickButtonColor = "ls15";
				clickButtonCallback = g_currentMission.hlGui.callbacks.vi["clickButton"];
				ownTable = {pageName="GroupManagerSetting", whatClick="loadProfil_",side=side};
				txtInfo = "Ladet das Selectierte Group Profil";
				--visible = false;				
			};
			[3] = {
				txtOverButton = "Delete Group Profil";				
				txtButton = "";
				txtBoldButton = true;
				txtButtonCallback = g_currentMission.hlGui.callbacks.vi["txtButton"];			
				clickButton = "buttonDelete";				
				clickButtonColor = "green";
				clickButtonCallback = g_currentMission.hlGui.callbacks.vi["clickButton"];
				ownTable = {pageName="GroupManagerSetting", whatClick="deleteProfil_",side=side};
				txtInfo = "Löscht das Selectierte Group Profil. Ein geladenes Profil kann nicht gelöscht werden. Lade erst ein anderes Profil (Achtung das löschen kann nicht rückgängig gemacht werden)";
				--visible = false;				
			};			
		};
		g_currentMission.hlGui.setGet:generateModSideLine({modName="VehicleInspector", page=VehicleInspector.global.hlGui.page["GroupManagerSetting"], side=side, lineButtons=buttons});
		------------------
		buttons = {
			[1] = {
				txtOverButton = "Groups";				
				txtButton = "";
				txtBoldButton = true;
				txtButtonCallback = g_currentMission.hlGui.callbacks.vi["txtButton"];			
				clickButton = "buttonDown";
				pullDownButton = true;
				pullDownCallback = g_currentMission.hlGui.callbacks.vi["pullDownButton"];
				ownTable = {pageName="GroupManagerSetting", whatClick="selectPullDownGroup_",side=side};
				txtInfo = "Markiere eine Groupe welches du bearbeiten willst. Die Group Profile befinden sich im Ordner ..modSettings/VehicleInspector/...";
				width = 60;
			};
			[2] = {
				txtOverButton = "Edit Group";				
				txtButton = "";
				txtBoldButton = true;
				txtButtonCallback = g_currentMission.hlGui.callbacks.vi["txtButton"];			
				clickButton = "buttonEdit";				
				clickButtonColor = "green";
				clickButtonCallback = g_currentMission.hlGui.callbacks.vi["clickButton"];
				ownTable = {pageName="GroupManagerSetting", whatClick="editGroup_",side=side};
				txtInfo = "Ändere den Namen der Selectierten Group";
				width = 20;				
			};
			[3] = {
				visible = false;
				width = 20;
			};
		};
		g_currentMission.hlGui.setGet:generateModSideLine({modName="VehicleInspector", page=VehicleInspector.global.hlGui.page["GroupManagerSetting"], side=side, lineButtons=buttons});
	end;
end;